import java.awt.*;
import com.ibm.eNetwork.ECL.*;

public class FilelLaunchApp extends Frame {

   Label Title;
   Label L_FileName;
   Label L_FileType;
   Label L_Disk;

   Button FileListButton;

   TextField TF_FileName;
   TextField TF_FileType;
   TextField TF_Disk;

   ECLPS ps;
   ECLOIA oia;

   Object callLock = new Object();

   public FilelLaunchApp()
   {
   }

   public FilelLaunchApp(ECLPS InitialPS, ECLOIA InitialOIA )
   {
      ps = InitialPS;
      oia = InitialOIA;

      setLayout(null);
      setBackground(Color.lightGray);
      resize(300, 225);

      // Obtain the following information from the user:
      // - Filename(s) for the filelist command
      // - Filetype(s) for the filelist command
      // - Disk or Drive letter(s) for the filelist command

      Title = new java.awt.Label("File List");
      Title.reshape(10, 25, 100, 25);
      Title.setFont(new Font("Dialog", Font.BOLD, 18));
      add(Title);

      L_FileName = new java.awt.Label("File Name");
      L_FileName.reshape(10, 60, 120, 25);
      add(L_FileName);
      TF_FileName = new java.awt.TextField();
      TF_FileName.reshape(140, 60, 150, 25);
      add(TF_FileName);

      L_FileType = new java.awt.Label("File Type");
      L_FileType.reshape(10, 95, 120, 25);
      add(L_FileType);
      TF_FileType = new java.awt.TextField();
      TF_FileType.reshape(140, 95, 150, 25);
      add(TF_FileType);

      L_Disk = new java.awt.Label("Disk");
      L_Disk.reshape(10, 130, 120, 25);
      add(L_Disk);
      TF_Disk = new java.awt.TextField();
      TF_Disk.reshape(140, 130, 150, 25);
      add(TF_Disk);

      FileListButton = new java.awt.Button("File List");
      FileListButton.reshape(10, 165, 280, 25);
      add(FileListButton);

      setTitle("Host Applications On-Demand");

      center(this);

   }

   static public void center(Window windowInstance) {
       Dimension screenSize = windowInstance.getToolkit().getScreenSize();
       Dimension windowSize = windowInstance.size();
       windowInstance.move((screenSize.width / 2) - (windowSize.width / 2), (screenSize.height / 2) - (windowSize.height / 2));
   }


   public synchronized void show()
   { super.show();
   }

   public void removeFilel()
   { dispose();
   }

   public boolean keyDown(Event evt, int key)
   {
     if (key == 9)                                   // TAB key is 9
     { // Tab Key was pressed
       if ( evt.target == TF_FileName)
       { if (evt.shiftDown()) { FileListButton.requestFocus(); }
         else                 { TF_FileType.requestFocus();  }
       }

       if ( evt.target == TF_FileType)
       { if (evt.shiftDown()) { TF_FileName.requestFocus(); }
         else                 { TF_Disk.requestFocus();   }
       }

       if ( evt.target == TF_Disk)
       { if (evt.shiftDown()) { TF_FileType.requestFocus(); }
         else                 { FileListButton.requestFocus();     }
       }

       if ( evt.target == FileListButton)
       { if (evt.shiftDown()) { TF_Disk.requestFocus();     }
         else                 { TF_FileName.requestFocus(); }
       }

       return true;
     }
     if (key == 10)            // ENTER key is 10
     { 
       postEvent(new Event(FileListButton, Event.ACTION_EVENT, null));
       return true;
     }
     return false;
   }

   public boolean handleEvent(Event event)
   {
     if (event.id == Event.WINDOW_DESTROY)
     {
       removeFilel();
       return true;
     }

     if (event.id == Event.ACTION_EVENT)
     {
        if ( event.target == FileListButton)
        { // Read Input Fields

          FileListButton.disable();

          CFilelData FileListData = new CFilelData();


          // Set up the Filelist data the the user filled in.
          FileListData.S_FileName = TF_FileName.getText();
          FileListData.S_FileType = TF_FileType.getText();
          FileListData.S_Disk     = TF_Disk.getText();


          // This thread will handle the filelist interaction with the 3270 screens.
          SAFilel FileListThread = new SAFilel(ps, oia, FileListData, callLock);

          FileListThread.start();

          // Wait for the thread the finish before returning back to the user.
          // (a thread "join" method could be used here, but that was found not
          // to work in all the java environments that were tested)
          synchronized(callLock)
          {
            try
            {
              callLock.wait();
            }
            catch(InterruptedException e)
            { System.out.println("FilelLaunchApp: wait Exception");
            }
          }

          FileListButton.enable();

          // Use another frame to display the results.
          FilelResultsApp SACL_FileListResultsApp = new FilelResultsApp(FileListData);

          SACL_FileListResultsApp.show();

          return true;
        }
     }
     return super.handleEvent(event);
   }
}



