import com.ibm.eNetwork.ECL.*;
import java.util.*;

/**
 * The intent of this class is to recognize when the screen needs to be
 * cleared.  We search for "MORE..."  in the lower right hand corner of the
 * screen and when found we send the the clear command to the presentation
 * space.
 */
class SAMore extends ScreenAction
{
   // The comments in ScreenAction and in SAVMLogin should cover the basic
   // logistics here.

   final static String[] MORE     = { "MORE..." };

   public SAMore()
   {
      SetFootprint(MORE, 1901);
   }

   public void TakeActionOnScreen (ECLPS ps, ScreenState MyScreenState)
   {
     int pos = 1;

     // Wait for presentation layer to "settle down".
     try { Thread.sleep(100); }
     catch (InterruptedException e)
     { /* System.out.println("SAFilel: catch sleep InterruptedException"); */ }

     pos = ps.SearchText(MORE[0], pos, ps.SEARCH_FORWARD);

     if (pos != 0)
     { // "MORE..."  on screen;
       try
       { // Clear the screen.
         ps.SendKeys(ps.CLEAR_STR);
       }
       catch(Exception e)
       { System.out.println("SAMore: SendKeys(CLEAR_STR) Exception");
       }
     }
   }
}
