import com.ibm.eNetwork.ECL.*;
import java.util.*;

class SAMsg10 extends ScreenAction implements HostLPConstants
{
   // Our first screen has a footprint of MSG10 in the upper
   // left corner
   final static String[] MSG10 = { "MSG10" };

   public SAMsg10()
   {
      SetFootprint(MSG10, 1);
      // 1 - start looking for MSG10 at first place in the screen
   }

   public boolean recognizes(ECLPS ps, ECLOIA oia, ScreenState MyScreenState,
                                                         CLogonData LogonData)
   {
      int i;
      int pos = startPos;

      for (i = 0; i < rows; i++)
      {
         // Start at the desired position on the screen, and check to see
         // if the strings listed in the footprint, are on this screen.
         // Search for the strings in the order they were given.
         // If one does not appear, then this screen does not
         // match the desired footprint.
         pos = ps.SearchText(buffer[i], pos, ps.SEARCH_FORWARD);
         if (pos == 0)
            return false;
      }

     // If we made it here, then the screen was recognized.
     // Wait for presentation layer to "settle down"
     // as described before in SALogon.java
      try { Thread.sleep(1000); }
      catch (InterruptedException e)
      { /* System.out.println("SAFilel: catch sleep InterruptedException"); */ }

     while (oia.InputInhibited() != oia.INHIBIT_NOTINHIBITED)
        try { Thread.sleep(100); }
        catch (InterruptedException e)
        { /* System.out.println("SAFilel: catch sleep InterruptedException"); */ }

     // Take action on this screen.
     TakeActionOnScreen(ps, MyScreenState, LogonData);

     return true;
   }

   public void TakeActionOnScreen (ECLPS ps, ScreenState MyScreenState,
                                             CLogonData LogonData)
   {
     // Check for the state, so that we only enter this clause once per session
     if (MyScreenState.GetState() == SS_INIT)
     {
       // Change the screen state, so that on another possible PS Event
       // (screen update) we don't again recognize the same screen, and
       // then call this action method twice, thus confusing us and the
       // screens!
       MyScreenState.UpdateState(SS_READY_FOR_LOGON);

       // This logic assumes that you are always going through a TN Server
       // to the host.  The TN Server screen prompts for the VM system
       // you want to go to.
       try
       {
         // This is how keys can be sent to the ECL session.
         ps.SendKeys(LogonData.S_VMSystem);
         ps.SendKeys(ps.ENTER_STR);
       }
       catch(Exception e)
       { System.out.println("SAMsg10: SendKeys(userid, psw) Exception");
       }

     }
   }

}
