//-------------------------------------------------------------------
// ECLField.GetScreen
//
// Iterate over list of fields and print each field's text contents.
//-------------------------------------------------------------------
import java.util.Properties;
import com.ibm.eNetwork.ECL.*;

public class Sample35 implements ECLAppletInterface
{

   /*********************************************************************
   * Constructor
   */
   public Sample35()
   {
   }


   /*********************************************************************
   * Method called by Host On-Demand when the applet is initialized.
   * This method is defined as part of the ECLAppletInterface
   */
   public void init(ECLSession s)
   {

       ECLPS        PS;           // PS object
       ECLFieldList fieldList;    // field list object
       ECLField     field;        // field object
       char[]       buff;         // Screen data buffer
       int          chars;

       try {
           PS = s.GetPS();                     // Get instance of ECLPS

           buff = new char[PS.GetSize() + 1];  // Allocate screen buffer

           fieldList = PS.GetFieldList(ECLFieldList.ALL_PLANES);     // Get pointer to field list

           for (field = fieldList.GetFirstField(ECLFieldList.ALL_FIELDS);       // First field
                field != null;                                                  // While more
                field = fieldList.GetNextField(field, ECLFieldList.ALL_FIELDS)) {    // Next field


               chars = field.GetScreen(buff, buff.length, ECLField.TEXT_PLANE);  // Get this field's text
               System.out.println(formatString(field.GetStartRow(),2,0) +","+ formatString(field.GetStartCol(),3,0) + ": " + String.valueOf(buff, 0, chars));      // Print "row,col: text"

               //chars = field.GetString(buff, buff.length);  // Get this fields text
               //System.out.println("GetString: " +formatString(field.GetStartRow(),2,0) +","+ formatString(field.GetStartCol(),3,0) + ": " + String.valueOf(buff, 0, chars));      // Print "row,col: text"
           }
       } catch (ECLErr e) {
           System.out.println("Sample35(): " + e.GetMsgText());
       }

   } // end sample

   // Utility method used to format strings
   private String formatString(int num, int length, int justify)
   {
     String numString = String.valueOf(num);
     int numLength = numString.length();
     StringBuffer retBuffer = new StringBuffer();

     if (numLength == length)
        return numString.toString();
     if (numLength > length)
        return numString.toString().substring(0,length);

     if (justify == 0)  // right justify
     {
        for (int i = length; numLength < i; i--)
           retBuffer.append('0');

        retBuffer.append(numString);
     }
     else               // left justify
     {
        retBuffer.append(numString);

        for (int i = length; numLength < i; i--)
           retBuffer.append(' ');
     }


     return retBuffer.toString();
   }

}
