//-------------------------------------------------------------------
// ECLFieldList.GetFirstField()
// ECLFieldList.GetNextField()
//
// Display starting position of every input (unprotected) field.
//-------------------------------------------------------------------
import java.util.Properties;
import com.ibm.eNetwork.ECL.*;

public class Sample41 implements ECLAppletInterface
{

   /*********************************************************************
   * Constructor
   */
   public Sample41()
   {
   }


   /*********************************************************************
   * Method called by Host On-Demand when the applet is initialized.
   * This method is defined as part of the ECLAppletInterface
   */
   public void init(ECLSession s)
   {

       ECLPS        PS;           // PS object
       ECLFieldList fieldList;    // field list object
       ECLField     field;        // field object

       PS = s.GetPS();            // Get instance of PS

       try {
          fieldList = PS.GetFieldList(ECLFieldList.ALL_PLANES);    // Get field list

          System.out.println("Start(Pos ,Row ,Col )  End(Pos ,Row ,Col ) Length(Len )");
          for (field = fieldList.GetFirstField(ECLFieldList.UNPROTECTED_FIELD);       // First field
               field != null;                               // While more
               field = fieldList.GetNextField(field, ECLFieldList.UNPROTECTED_FIELD)) {    // Next field

            System.out.println("Start(" + formatString(field.GetStart(),4,0) +","+
                                          formatString(field.GetStartRow(),3,0) +","+
                                          formatString(field.GetStartCol(),4,0) +")  "+
                               "End("   + formatString(field.GetEnd(),4,0) +","+
                                          formatString(field.GetEndRow(),3,0) +","+
                                          formatString(field.GetEndCol(),4,0) +")  "+
                               "Length("+ formatString(field.GetLength(),4,0) +")");
               }
       } catch (ECLErr e) { System.out.println("Sample41(): " + e.GetMsgText()); }

   } // end sample

   // Utility method used to format strings
   private String formatString(int num, int length, int justify)
   {
     String numString = String.valueOf(num);
     int numLength = numString.length();
     StringBuffer retBuffer = new StringBuffer();

     if (numLength == length)
        return numString.toString();
     if (numLength > length)
        return numString.toString().substring(0,length);

     if (justify == 0)  // right justify
     {
        for (int i = length; numLength < i; i--)
           retBuffer.append('0');

        retBuffer.append(numString);
     }
     else               // left justify
     {
        retBuffer.append(numString);

        for (int i = length; numLength < i; i--)
           retBuffer.append(' ');
     }


     return retBuffer.toString();
   }

}
