//-------------------------------------------------------------------
// ECLPS.SearchText
//
// Search for a string in various parts of the screen.
//-------------------------------------------------------------------
import java.util.Properties;
import com.ibm.eNetwork.ECL.*;

public class Sample63 implements ECLAppletInterface
{

   /*********************************************************************
   * Constructor
   */
   public Sample63()
   {
   }


   /*********************************************************************
   * Method called by Host On-Demand when the applet is initialized.
   * This method is defined as part of the ECLAppletInterface
   */
   public void init(ECLSession s)
   {

      ECLPS  ps = s.GetPS();               // Get instance of ECLPS
      String findStr = new String("IBM");  // String to search for
      int    pos;                          // Position of search result

      // Search forward
      System.out.println("Searching for '" + findStr + "'...");
      if ((pos = ps.SearchText(findStr, ECLPS.SEARCH_FORWARD)) != 0)
        System.out.println("Found at " + pos + "!!");
      else
        System.out.println("Not found!");

      // Search backward on line 1
      try {
         System.out.println("Searching backwards on line 1 for '" + findStr + "'...");
         if ((pos = ps.SearchText(findStr, 1, 80, ECLPS.SEARCH_BACKWARD)) != 0)
           System.out.println("Found at location " + pos + "!!");
         else
           System.out.println("Not found!");
         } catch (ECLErr e) {
            System.out.println("Sample63():1: " + e.GetMsgText());
      }

      // Backward, full screen search
      pos = ps.SearchText(findStr, ECLPS.SEARCH_BACKWARD);
      if (pos != 0)
      {
         try {
            System.out.println("Last occurance on the screen is at row "+ps.ConvertPosToRow(pos) + 
                                                               ", column " + ps.ConvertPosToCol(pos));
         } catch (ECLErr e) {
            System.out.println("Sample63():2: " + e.GetMsgText());
         }
      }

   } // end sample

}
